#include <stdio.h>
#include <stdlib.h>

#define T_BASE    0
#define T_INTEGER 1
#define T_STRING  2

typedef struct
{
  int type;
} t_base;

typedef struct
{
  int type;
  int content;
} t_integer;

typedef struct
{
  int type;
  char *content;
} t_string;

void print_object (t_base *this)
{
  if (this->type == T_INTEGER)
    printf ("Integer: %d\n", ((t_integer *) this)->content);
  else if (this->type == T_STRING)
    printf ("String: \"%s\"\n", ((t_string *) this)->content);
}

t_integer *new_integer (int i)
{
  t_integer *p = malloc (sizeof (t_integer));
  p->type = T_INTEGER;
  p->content = i;
  return p;
}

t_string *new_string (char *s)
{
  t_string *p = malloc (sizeof (t_string));
  p->type = T_STRING;
  p->content = s;
  return p;
}

int main (void)
{
  t_base *object[] = { (t_base *) new_integer (42),
                       (t_base *) new_string ("Hello, world!"),
                       NULL };

  for (int i = 0; object[i]; i++)
    print_object (object[i]);

  return 0;
}
