#include <stdio.h>
#include <stdlib.h>

#define ANIMAL     0
#define WITH_WINGS 1
#define WITH_LEGS  2

union animal;

typedef struct
{
  int type;
  char *name;
  void (*print) (union animal *this);
} base;

typedef struct
{
  int type;
  char *name;
  void (*print) (union animal *this);
  int wings;
} with_wings;

typedef struct
{
  int type;
  char *name;
  void (*print) (union animal *this);
  int legs;
} with_legs;

typedef union animal
{
  base b;
  with_wings w;
  with_legs l;
} animal;

void print_with_wings (animal *this)
{
  printf ("A %s has %d wings.\n", this->b.name, this->w.wings);
}

void print_with_legs (animal *this)
{
  printf ("A %s has %d legs.\n", this->b.name, this->l.legs);
}

animal *new_with_wings (char *name, int wings)
{
  animal *a = malloc (sizeof (with_wings));
  a->b.type = WITH_WINGS;
  a->b.name = name;
  a->b.print = print_with_wings;
  a->w.wings = wings;
  return a;
}

animal *new_with_legs (char *name, int legs)
{
  animal *a = malloc (sizeof (with_legs));
  a->b.type = WITH_LEGS;
  a->b.name = name;
  a->b.print = print_with_legs;
  a->l.legs = legs;
  return a;
}

int main (void)
{
  animal *a[2] = { new_with_wings ("duck", 2),
                   new_with_legs ("cow", 4) };
  for (int i = 0; i < 2; i++)
    a[i]->b.print (a[i]);
  return 0;
}
