#include <stdio.h>

struct TBase
{
  virtual void print () = 0;
};

struct TInteger: TBase
{
  int content;
  virtual void print ();
  TInteger (int i);
};

struct TString: TBase
{
  char *content;
  virtual void print ();
  TString (char *s);
};

void TInteger::print ()
{
  printf ("Integer: %d\n", content);
}

void TString::print ()
{
  printf ("String: \"%s\"\n", content);
}

TInteger::TInteger (int i)
{
  content = i;
}

TString::TString (char *s)
{
  content = s;
}

int main (void)
{
  TBase *object[] = { new TInteger (42),
                      new TString ("Hello, world!"),
                      NULL };

  for (int i = 0; object[i]; i++)
    object[i]->print ();

  return 0;
}
