#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

void insert (node **root, int content)
{
  if (*root == NULL)
    {
      node *p = malloc (sizeof (node));
      p->content = content;
      p->left = NULL;
      p->right = NULL;
      *root = p;
    }
  else if (content > (*root)->content)
    insert (&(*root)->right, content);
  else
    insert (&(*root)->left, content);
}

void output (node *root)
{
  if (root)
    {
      output (root->left);
      printf ("%d\n", root->content);
      output (root->right);
    }
}

int main (void)
{
  node *root = NULL;
  for (int i = 0; i < 30; i++)
    insert (&root, rand () % 1000 + 1);
  output (root);
  return 0;
}
