#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
  int content;
  struct node *left, *right;
} node;

void insert (node **root, int content)
{
  if (*root == NULL)
    {
      node *p = malloc (sizeof (node));
      p->content = content;
      p->left = NULL;
      p->right = NULL;
      *root = p;
    }
  else if (content > (*root)->content)
    insert (&(*root)->right, content);
  else
    insert (&(*root)->left, content);
}

void output (node *root)
{
  if (root)
    {
      output (root->left);
      printf ("%d\n", root->content);
      output (root->right);
    }
}

int output_tree_layer (node *root, int depth, int current_depth)
{
  int result = 0;
  if (root)
    {
      if (output_tree_layer (root->left, depth, current_depth + 1))
        result = 1;
      if (depth == current_depth)
        {
          printf ("%d ", root->content);
          result = 1;
        }
      if (output_tree_layer (root->right, depth, current_depth + 1))
        result = 1;
    }
  return result;
}

void output_tree (node *root)
{
  if (root)
    {
      int depth = 0;
      while (output_tree_layer (root, depth, 0))
        { 
          printf ("\n");
          depth++;
        }
    }
}

int main (void)
{
  node *root = NULL;
  for (int i = 0; i < 30; i++)
    insert (&root, rand () % 1000 + 1);
  output_tree (root);
  return 0;
}
